--NazUpg: Dod. faktury
--PopisUpg: Uloen sla novho dokladu
--KontrolaUpg: 
--ChybaUpg:
--VypniOstatni: 0
--VypniPoUpg: 0
--ChybaHlasit: 1
GO
ALTER TRIGGER dbo.trDfDokInsUpd ON dbo.DfDok
FOR INSERT,UPDATE
AS
BEGIN
set nocount on
------------------------------------------------------------------
-- jak akce
declare @Akce char(1)
if (select count(*) from inserted)>0   select @Akce='I'
if (select count(*) from  deleted)>0   select @Akce=case when @Akce='I' then 'U' else 'D' end
if @Akce is null
 return
------------------------------------------------------------------
declare @Hlaska varchar(4000) select @Hlaska=''
declare @IdDrdok char(2) select @IdDrdok=max(IdDrdok) from inserted
---------------------------- DUZP ped dnem pjmu --------------------------
-- spolen pro insert i update
select @Hlaska='Chyba: DUZP je po dni pjmu '+@IdDrdok+' '+convert(varchar(15),min(i.CisDok))+char(13)
 from inserted i join dbo.ExObdUc o (nolock) on i.IdDrdok=o.IdDrdok and i.Obd=o.Obd and i.Rok=o.Rok
 where isnull(i.DenDph,i.DenDok)>i.DenDok
if  @Hlaska>''
begin
 raiserror (@Hlaska,11,2)
 rollback transaction
 return
end
---------------------------- patn den dokladu vzhledem k obdob --------------------------
-- spolen pro insert i update
select @Hlaska='Chyba etnho obdob '+@IdDrdok+' '+convert(varchar(15),min(i.CisDok))+char(13)
 from inserted i join dbo.ExObdUc o (nolock) on i.IdDrdok=o.IdDrdok and i.Obd=o.Obd and i.Rok=o.Rok
 where
  (JeZmenaObdUc=0 and
   (case when i.DenDok<'20110501' then i.DenDok else isnull(i.DenDph,i.DenDok) end<o.DenOd or
    case when i.DenDok<'20110501' then i.DenDok else isnull(i.DenDph,i.DenDok) end>o.DenDo
   )
  )
  or  (@Akce='I' and not o.PovolUc>'0')
if  @Hlaska>''
begin
 raiserror (@Hlaska,11,2)
 rollback transaction
 return
end
select @Hlaska='Chyba obdob DPH '+@IdDrdok+' '+convert(varchar(15),min(i.CisDok))
 from inserted i join dbo.ExObdDph o (nolock) on i.IdDrdok=o.IdDrdok and i.ObdDph=o.ObdDph and i.RokDph=o.RokDph
 where
  (JeZmenaObdDph=0 and
   (case when i.DenDok<'20110501' then isNull(i.DenDph,convert(datetime,'19000101')) else i.DenDok end<o.DenOd or
    case when i.DenDok<'20110501' then isNull(i.DenDph,convert(datetime,'19000101')) else i.DenDok end>o.DenDo
   )
  )
  or (@Akce='I' and not o.PovolDph>'0')
if  @Hlaska>''
begin
 raiserror (@Hlaska,11,2)
 rollback transaction
 return
end
----------------------------------- kontrola smlouvy -------------------------------------------
-- jen pro insert, pro update je ne
if @Akce='I'
begin
 select @Hlaska='Smlouva '+@IdDrdok+' '+convert(varchar(15),min(i.CisDok))+' nepat adrestovi, pjemci ani nen veobecn (adrest=0), nebo neodpovd typ komise nebo datum dokladu.'
  from inserted i
   left join dbo.AdSmlNak s (nolock) on s.SmlAdr=i.SmlAdr and s.Komise=i.Komise and (s.IdAdr=i.IdAdr or s.IdAdr=i.IdAdrPri or s.IdAdr='0') and not s.DenOd>i.DenDok and not s.DenDo<i.DenDok
  where s.SmlAdr is null
 if  @Hlaska>''
 begin
  raiserror (@Hlaska,11,2)
  rollback transaction
  return
 end
end
-------------------------- doplnn text (insert a radji i update) --------------------------
insert dbo.DfTxt (CisDok,   Uvod  ,   Zaver ,  IdTxt1,  IdTxt2,  IdTxt3,  IdTxt4,  IdTxt5) 
 select         i.CisDok,tu.TxtTxt,tz.TxtTxt,r.IdTxt1,r.IdTxt2,r.IdTxt3,r.IdTxt4,r.IdTxt5
  from inserted i
   join DfRada r (nolock) on r.IdRada=i.IdRada
   join ExTxt tu (nolock) on tu.IdTxt=r.IdTxtUvod
   join ExTxt tz (nolock) on tz.IdTxt=r.IdTxtZaver
   left join dbo.DfTxt t (nolock) on t.CisDok=i.CisDok
  where t.CisDok is null
----------------------------------- uloen novho sla -------------------------------------------
-- jen pro insert, pro update je ne
if @Akce='I'
begin
 -- zapu nejnovj slo do seznamu sel podle ady a roku
 update cd set cd.CisDokMax=x.CisDok
  from
   (
    select i.IdDrdok,i.IdRada,i.Rok,CisDok=max(i.CisDok) from inserted i group by i.IdDrdok,i.IdRada,i.Rok
   ) x
   join dbo.ExCisDok cd on cd.IdDrdok=x.IdDrdok and cd.IdRada=x.IdRada and cd.Rok=x.Rok and x.CisDok>cd.CisDokMax
 -- pokud pidvm novou adu i rok
 if exists(
  select *
   from inserted i left join dbo.ExCisDok cd (nolock) on cd.IdDrdok=i.IdDrdok and cd.IdRada=i.IdRada and cd.Rok=i.Rok
   where cd.IdExCisDok is null
 )
  insert dbo.ExCisDok(IdDrdok,  IdRada,  Rok,CisDokPoc              ,CisDokMax)
   select           i.IdDrdok,i.IdRada,i.Rok,CisDokPoc=min(i.CisDok),CisDokMax=max(i.CisDok)
     from inserted i
      left join dbo.ExCisDok cd (nolock) on cd.IdDrdok=i.IdDrdok and cd.IdRada=i.IdRada and cd.Rok=i.Rok
     where cd.IdExCisDok is null
     group by i.IdDrdok,i.IdRada,i.Rok
end
------------------------------------------------------------------------------------------------
-- te u kon insert a hraje se jen s update
if @Akce='I'
 return
------------------------- nelze zmnit slo a druh dokladu --------------------------------
select @Hlaska='Nelze mnit slo nebo druh dokladu '+@IdDrdok+' '+convert(varchar(15),min(i.CisDok))
 from inserted i
  left join deleted d on d.CisDok=i.CisDok and d.IdDrdok=i.IdDrdok
 where d.CisDok is null
if  @Hlaska>''
begin
 raiserror (@Hlaska,11,2)
 rollback transaction
 return
end
--------------------- zmna smlouvy ------------------------
-- pi update se kontroluje smlouva jen v ppad, e zmnili parametry pro vbr smlouvy
select @Hlaska='Smlouva '+@IdDrdok+' '+convert(varchar(15),min(i.CisDok))+'nepat adrestovi, pjemci ani nen veobecn (adrest=0), nebo neodpovd typ komise nebo datum dokladu.'
 from inserted i
  join deleted d on d.CisDok=i.CisDok and not (i.SmlAdr=d.SmlAdr and i.IdAdr=d.IdAdr and i.IdAdrPri=d.IdAdrPri and i.Komise=d.Komise and i.DenDok=d.DenDok)
  left join dbo.AdSmlNak s (nolock) on s.SmlAdr=i.SmlAdr and s.Komise=i.Komise and (s.IdAdr=i.IdAdr or s.IdAdr=i.IdAdrPri or s.IdAdr='0') and not s.DenOd>i.DenDok and not s.DenDo<i.DenDok
 where s.SmlAdr is null
if  @Hlaska>''
begin
 raiserror (@Hlaska,11,2)
 rollback transaction
 return
end
--------------------- zmna obdob, z nich aspo jedno je zakzan ------------------------
select @Hlaska='Zmna neplatnho etnho obdob '+@IdDrdok+' '+convert(varchar(15),min(i.CisDok))+char(13)
 from inserted i
  join deleted d on i.CisDok=d.CisDok
  join dbo.ExObdUc  oi (nolock) on i.IdDrdok=oi.IdDrdok and i.Obd=oi.Obd and i.Rok=oi.Rok
  join dbo.ExObdUc  od (nolock) on d.IdDrdok=od.IdDrdok and d.Obd=od.Obd and d.Rok=od.Rok
 where not (i.Obd=d.Obd and i.Rok=d.Rok) and not (oi.PovolUc>'0' and od.PovolUc>'0')
select @Hlaska='Zmna neplatnho obdob DPH '+@IdDrdok+' '+convert(varchar(15),min(i.CisDok))
 from inserted i
  join deleted d on i.CisDok=d.CisDok
  join dbo.ExObdDph oi (nolock) on i.IdDrdok=oi.IdDrdok and i.ObdDph=oi.ObdDph and i.RokDph=oi.RokDph
  join dbo.ExObdDph od (nolock) on d.IdDrdok=od.IdDrdok and d.ObdDph=od.ObdDph and d.RokDph=od.RokDph
 where not (i.ObdDph=d.ObdDph and i.RokDph=d.RokDph) and not (oi.PovolDph>'0' and od.PovolDph>'0')
if  @Hlaska>''
begin
 raiserror (@Hlaska,11,2)
 rollback transaction
 return
end
-------------------- uzaven doklady - podpis, blokovn, obdob - kontrola jen zkladnch parametr -------------------------
select @Hlaska='Zmna dokladu v uzavenm obdob nebo podepsanho i zablokovanho dokladu '+@IdDrdok+' '+convert(varchar(15),min(i.CisDok))
 from
  (
   select i.CisDok,i.IdDrdok from inserted i join dbo.ExPodpisUc  p (nolock) on i.IdDrdok=p.IdDrdok and i.CisDok=p.CisDok union
   select i.CisDok,i.IdDrdok from inserted i join dbo.ExPodpisDok p (nolock) on i.IdDrdok=p.IdDrdok and i.CisDok=p.CisDok union
   select i.CisDok,i.IdDrdok from inserted i join deleted         d          on i.IdDrdok=d.IdDrdok and i.CisDok=d.CisDok where i.Blok>'0' and d.Blok>'0' union
   select i.CisDok,i.IdDrdok from inserted i join dbo.ExObdUc     o (nolock) on i.IdDrdok=o.IdDrdok and i.Obd=o.Obd and i.Rok=o.Rok where not o.PovolUc>'0' union
   select d.CisDok,d.IdDrdok from deleted  d join dbo.ExObdUc     o (nolock) on d.IdDrdok=o.IdDrdok and d.Obd=o.Obd and d.Rok=o.Rok where not o.PovolUc>'0'
  ) x
  join inserted i on i.CisDok=x.CisDok
  join deleted d on d.CisDok=x.CisDok
 where not
  (i.DenDok=d.DenDok and i.IdAdr=d.IdAdr and i.IdAdrPri=d.IdAdrPri and i.CenaCelkKc=d.CenaCelkKc and i.CenaCelkMena=d.CenaCelkMena and i.IdMena=d.IdMena and i.Kurs=d.Kurs
   and i.IdStr=d.IdStr and i.IdZak=d.IdZak and i.IdCin=d.IdCin and i.IdSbo=d.IdSbo and i.IdAut=d.IdAut and i.Obd=d.Obd and i.Rok=d.Rok and i.Komise=d.Komise and i.SmlAdr=d.SmlAdr and i.DenDph=d.DenDph
  )
if  @Hlaska>''
begin
 raiserror (@Hlaska,11,2)
 rollback transaction
 return
end
-----------------------------------------------------------------------------------------------------------------
declare
@StaraSlevaProc numeric(19,6),
@NovaSlevaProc numeric(19,6),
@ZaokRadCenaKc smallInt,
@ZaokRadCenaMena smallInt,
@DphFakNevracetDleCeniku char(1)
select @ZaokRadCenaKc          =dbo.fnChar2Int(dbo.fnExNastav('ZaokRadCenaKc',4,default))
select @ZaokRadCenaMena        =dbo.fnChar2Int(dbo.fnExNastav('ZaokRadCenaKc',4,@ZaokRadCenaKc))
select @DphFakNevracetDleCeniku=dbo.fnChar2Bit(dbo.fnExNastav('DphFakNevracetDleCeniku','0',default))
------------------ pepoet cen pi zmn slev - ignoruje ppady, kdy byla pvodn sleva 100% -------------
if exists(select i.CisDok from inserted i join deleted d on i.CisDok=d.CisDok where i.SlevaProc+i.SlevaHotProc<>d.SlevaProc+d.SlevaHotProc and d.SlevaProc+d.SlevaHotProc<>100)
begin
 Update r set
   @NovaSlevaProc =i.SlevaProc+i.SlevaHotProc,
   @StaraSlevaProc=d.SlevaProc+d.SlevaHotProc,
   CenaCelkKc     =                                 round( (r.CenaCelkKc/(1-@StaraSlevaProc/100.0))*(1-@NovaSlevaProc/100)           , @ZaokRadCenaKc),
   CenaMjKc       =case when MnozCelk=0 then 0 else round(((r.CenaCelkKc/(1-@StaraSlevaProc/100.0))*(1-@NovaSlevaProc/100))/MnozCelk , @ZaokRadCenaKc) end,
   CenaVahaKc     =case when VahaCelk=0 then 0 else round(((r.CenaCelkKc/(1-@StaraSlevaProc/100.0))*(1-@NovaSlevaProc/100))/VahaCelk , @ZaokRadCenaKc) end
  from dbo.DfRad r join inserted i on i.CisDok=r.CisDok join deleted d on d.CisDok=i.CisDok
  where (rtrim(i.IdMena)<='0' or i.Kurs=0) and i.SlevaProc+i.SlevaHotProc<>d.SlevaProc+d.SlevaHotProc and d.SlevaProc+d.SlevaHotProc<>100
 Update r set
   @NovaSlevaProc =i.SlevaProc+i.SlevaHotProc,
   @StaraSlevaProc=d.SlevaProc+d.SlevaHotProc,
   CenaCelkMena   =                                 round((r.CenaCelkMena/(1-@StaraSlevaProc/100.0))*(1-@NovaSlevaProc/100)                 ,@ZaokRadCenaMena),
   CenaMjMena     =case when MnozCelk=0 then 0 else round((r.CenaCelkMena/(1-@StaraSlevaProc/100.0))*(1-@NovaSlevaProc/100)/MnozCelk        ,@ZaokRadCenaMena) end,
   CenaVahaMena   =case when VahaCelk=0 then 0 else round((r.CenaCelkMena/(1-@StaraSlevaProc/100.0))*(1-@NovaSlevaProc/100)/VahaCelk        ,@ZaokRadCenaMena) end,
   CenaCelkKc     =                                 round((r.CenaCelkMena/(1-@StaraSlevaProc/100.0))*(1-@NovaSlevaProc/100)*i.Kurs          ,@ZaokRadCenaKc),
   CenaMjKc       =case when MnozCelk=0 then 0 else round((r.CenaCelkMena/(1-@StaraSlevaProc/100.0))*(1-@NovaSlevaProc/100)*i.Kurs/MnozCelk ,@ZaokRadCenaKc)end,
   CenaVahaKc     =case when VahaCelk=0 then 0 else round((r.CenaCelkMena/(1-@StaraSlevaProc/100.0))*(1-@NovaSlevaProc/100)*i.Kurs/VahaCelk ,@ZaokRadCenaKc)end
  from dbo.DfRad r join inserted i on i.CisDok=r.CisDok join deleted d on d.CisDok=i.CisDok
  where rtrim(i.IdMena)>'0' and i.Kurs<>0 and i.SlevaProc+i.SlevaHotProc<>d.SlevaProc+d.SlevaHotProc and d.SlevaProc+d.SlevaHotProc<>100
end
----------------------------------------------- zmna skupiny DPH ----------------------------------------------
if @Akce='U'
begin
 declare @TabDph table (CisDok decimal(15,0) NOT NULL primary key, ZmenilRadky bit
  ,IdDphStara char(10) COLLATE SQL_Czech_CP1250_CI_AS, IdTypDphStara char(10) COLLATE SQL_Czech_CP1250_CI_AS
  ,IdDphNova  char(10) COLLATE SQL_Czech_CP1250_CI_AS, IdTypDphNova  char(10) COLLATE SQL_Czech_CP1250_CI_AS
 )
 insert @TabDph(CisDok,  IdDphStara,   IdTypDphStara,  IdDphNova,IdTypDphNova, ZmenilRadky )
  select      i.CisDok,d.IdDph     ,dd.IdTypDph     ,i.IdDph    ,di.IdTypDph , 0
   from inserted i join deleted d on d.CisDok=i.CisDok
    join DpDph di (nolock) on di.IdDph=i.IdDph
    join DpDph dd (nolock) on dd.IdDph=d.IdDph
   where not i.IdDph=d.IdDph
 if  exists(select * from @TabDph)
 begin
  if not @DphFakNevracetDleCeniku>'0'
  begin
   if  exists(select * from @TabDph where ZmenilRadky=0)
    if exists(select i.CisDok         from @TabDph i join dbo.DfRad r (nolock) on i.CisDok=r.CisDok join dbo.DpDph sr (nolock) on sr.IdDph=r.IdDph and not sr.IdTypDph>'0'                                                    where not i.IdDphNova>'0'                            and not i.IdTypDphStara>'0') -- vracm se na nulu
    begin
     update i set ZmenilRadky=1       from @TabDph i join dbo.DfRad r (nolock) on i.CisDok=r.CisDok join dbo.DpDph sr (nolock) on sr.IdDph=r.IdDph and not sr.IdTypDph>'0' join dbo.CeZbozi c (nolock) on c.IdZbozi=r.IdZbozi where not i.IdDphNova>'0'                            and not i.IdTypDphStara>'0'
     update r set r.IdDph=c.IdDph     from @TabDph i join dbo.DfRad r          on i.CisDok=r.CisDok join dbo.DpDph sr (nolock) on sr.IdDph=r.IdDph and not sr.IdTypDph>'0' join dbo.CeZbozi c (nolock) on c.IdZbozi=r.IdZbozi where not i.IdDphNova>'0'                            and not i.IdTypDphStara>'0'
    end
   if  exists(select * from @TabDph where ZmenilRadky=0)
    if exists(select i.CisDok         from @TabDph i join dbo.DfRad r (nolock) on i.CisDok=r.CisDok join dbo.DpDph sr (nolock) on sr.IdDph=r.IdDph and not sr.IdTypDph>'0'                                                    where     i.IdDphNova>'0' and     i.IdTypDphNova>'0' and not i.IdTypDphStara>'0' and i.IdDphStara>'0') -- z tvrd na dovoz/penos
    begin
     update i set ZmenilRadky=1       from @TabDph i join dbo.DfRad r (nolock) on i.CisDok=r.CisDok join dbo.DpDph sr (nolock) on sr.IdDph=r.IdDph and not sr.IdTypDph>'0' join dbo.CeZbozi c (nolock) on c.IdZbozi=r.IdZbozi where     i.IdDphNova>'0' and     i.IdTypDphNova>'0' and not i.IdTypDphStara>'0' and i.IdDphStara>'0'
     update r set r.IdDph=c.IdDph     from @TabDph i join dbo.DfRad r          on i.CisDok=r.CisDok join dbo.DpDph sr (nolock) on sr.IdDph=r.IdDph and not sr.IdTypDph>'0' join dbo.CeZbozi c (nolock) on c.IdZbozi=r.IdZbozi where     i.IdDphNova>'0' and     i.IdTypDphNova>'0' and not i.IdTypDphStara>'0' and i.IdDphStara>'0'
    end
  end
  if  exists(select * from @TabDph where ZmenilRadky=0)
   if  exists(select i.CisDok         from @TabDph i join dbo.DfRad r (nolock) on i.CisDok=r.CisDok join dbo.DpDph sr (nolock) on sr.IdDph=r.IdDph and not sr.IdTypDph>'0'                                                    where     i.IdDphNova>'0' and not i.IdTypDphNova>'0')
   begin
     update i set ZmenilRadky=1       from @TabDph i join dbo.DfRad r (nolock) on i.CisDok=r.CisDok join dbo.DpDph sr (nolock) on sr.IdDph=r.IdDph and not sr.IdTypDph>'0'                                                    where     i.IdDphNova>'0' and not i.IdTypDphNova>'0'
     update r set r.IdDph=i.IdDphNova from @TabDph i join dbo.DfRad r          on i.CisDok=r.CisDok join dbo.DpDph sr (nolock) on sr.IdDph=r.IdDph and not sr.IdTypDph>'0'                                                    where     i.IdDphNova>'0' and not i.IdTypDphNova>'0'
   end
 end
 -- pepotu zmnn doklady pro DPH
 if  exists(select * from @TabDph where ZmenilRadky=0)
 begin
  declare @CisDok decimal(15,0)
  select  @CisDok=min(CisDok) from @TabDph where ZmenilRadky=0
  while   @CisDok is not null
  begin
   insert dbo.DpDokGen(CisDok,IdDrdok) select @CisDok,@IdDrdok
   select @CisDok=min(CisDok) from @TabDph where ZmenilRadky=0 and CisDok>@CisDok
  end
 end
end
-------------------------------------- zmna kursu -------------------------------------------------
if @Akce='U'
begin
 if exists(select i.CisDok from inserted i join deleted d on i.CisDok=d.CisDok where not i.Kurs=d.Kurs and not i.Kurs=0)
 begin
  update r set
    CenaCelkMena   =case when     r.CenaCelkMena=0 then                             round(r.CenaCelkKc  /i.Kurs,@ZaokRadCenaMena)                                                                   else r.CenaCelkMena end,
    CenaMjMena     =case when     r.CenaMjMena  =0 then case when r.MnozCelk=0 then round(r.CenaMjKc    /i.Kurs,@ZaokRadCenaMena) else round(r.CenaCelkKc  /r.MnozCelk/i.Kurs,@ZaokRadCenaMena) end else r.CenaMjMena   end,
    CenaVahaMena   =case when     r.CenaVahaMena=0 then case when r.VahaCelk=0 then round(r.CenaVahaKc  /i.Kurs,@ZaokRadCenaMena) else round(r.CenaCelkKc  /r.VahaCelk/i.Kurs,@ZaokRadCenaMena) end else r.CenaVahaMena end,
    CenaCelkKc     =case when not r.CenaCelkMena=0 then                             round(r.CenaCelkMena*i.Kurs,@ZaokRadCenaKc  )                                                                   else r.CenaCelkKc   end,
    CenaMjKc       =case when not r.CenaMjMena  =0 then case when r.MnozCelk=0 then round(r.CenaMjMena  *i.Kurs,@ZaokRadCenaKc  ) else round(r.CenaCelkMena/r.MnozCelk*i.Kurs,@ZaokRadCenaKc  ) end else r.CenaMjKc     end,
    CenaVahaKc     =case when not r.CenaVahaMena=0 then case when r.VahaCelk=0 then round(r.CenaVahaMena*i.Kurs,@ZaokRadCenaKc  ) else round(r.CenaCelkMena/r.VahaCelk*i.Kurs,@ZaokRadCenaKc  ) end else r.CenaVahaKc   end
   from dbo.DfRad r join inserted i on i.CisDok=r.CisDok join deleted d on d.CisDok=i.CisDok
   where not i.Kurs=d.Kurs and not i.Kurs=0 and not r.CenaCelkMena=0
 end
end
---------------------------------------- jen fakturace ----------------------------------------------
if exists
 (select i.CisDok from inserted i where not
  (i.UhraditKc  =i.CenaCelkKc  -i.ZalKc  -i.ZadrzKc  -i.DobroKc  +i.ZaokKc   and
   i.UhraditMena=i.CenaCelkMena-i.ZalMena-i.ZadrzMena-i.DobroMena+i.ZaokMena and
   i.ZbyvaKc    =i.CenaCelkKc  -i.ZalKc  -i.ZadrzKc  -i.DobroMena+i.ZaokKc  -i.PlatbaKc and
   i.ZbyvaMena  =i.CenaCelkMena-i.ZalMena-i.ZadrzMena-i.DobroMena+i.ZaokMena-i.PlatbaMena
 ))
 update h set
     UhraditKc  =h.CenaCelkKc  -h.ZalKc  -h.ZadrzKc  -h.DobroKc  +h.ZaokKc,
     UhraditMena=h.CenaCelkMena-h.ZalMena-h.ZadrzMena-h.DobroMena+h.ZaokMena,
     ZbyvaKc    =h.CenaCelkKc  -h.ZalKc  -h.ZadrzKc  -h.DobroKc  +h.ZaokKc  -h.PlatbaKc,
     ZbyvaMena  =h.CenaCelkMena-h.ZalMena-h.ZadrzMena-h.DobroMena+h.ZaokMena-h.PlatbaMena
  from dbo.DfDok h join inserted i on i.CisDok=h.CisDok
  where not
  (h.UhraditKc  =h.CenaCelkKc  -h.ZalKc  -h.ZadrzKc  -h.DobroKc  +h.ZaokKc   and
   h.UhraditMena=h.CenaCelkMena-h.ZalMena-h.ZadrzMena-h.DobroMena+h.ZaokMena and
   h.ZbyvaKc    =h.CenaCelkKc  -h.ZalKc  -h.ZadrzKc  -h.DobroKc  +h.ZaokKc  -h.PlatbaKc and
   h.ZbyvaMena  =h.CenaCelkMena-h.ZalMena-h.ZadrzMena-h.DobroMena+h.ZaokMena-h.PlatbaMena
   )
END
GO