--NazUpg: Kurs v bankovnm vpisu
--PopisUpg: Pepoet cen pi zmn kurzu v hlavice bankovnho vpisu
--ChybaUpg: 
--VypniOstatni: 0
--VypniPoUpg: 1
--ChybaHlasit: 1
GO
ALTER TRIGGER dbo.trBaDokInsUpdDel ON dbo.BaDok
FOR INSERT,UPDATE,DELETE
AS
BEGIN
set nocount on
---------------- uren akce, ppadn ukonen, kdy se nic nedje --------------
declare @Akce char(1)
if (select count(*) from inserted)>0   select @Akce='I'
if (select count(*) from  deleted)>0   select @Akce=case when @Akce='I' then 'U' else 'D' end
if @Akce is null
 return
-----------------------------------------------------------------------------------------------------------------
declare
@ZaokRadCenaKc smallInt,
@ZaokRadCenaMena smallInt
select @ZaokRadCenaKc  =dbo.fnChar2Int(dbo.fnExNastav('ZaokRadCenaKc',4,default))
select @ZaokRadCenaMena=dbo.fnChar2Int(dbo.fnExNastav('ZaokRadCenaKc',4,@ZaokRadCenaKc))
--------------- kontrola na uzaven doklady - podpis, blokovn, obdob --------------
declare @Hlaska varchar(8000)
select @Hlaska=''
select @Hlaska=@Hlaska+x.IdDrdok+' '+convert(varchar(15),x.CisDok)+char(13)
 from
  (
   select x.CisDok,x.IdDrdok from (select distinct CisDok,IdDrdok         from inserted union select distinct CisDok,IdDrdok         from deleted) x join dbo.ExPodpisUc  p on p.IdDrdok=x.IdDrdok and p.CisDok=x.CisDok union all
   select x.CisDok,x.IdDrdok from (select distinct CisDok,IdDrdok,Rok,Obd from inserted union select distinct CisDok,IdDrdok,Rok,Obd from deleted) x join dbo.ExObdUc     o on o.IdDrdok=x.IdDrdok and o.Obd=x.Obd and o.Rok=x.Rok where not o.PovolUc >'0' union all
   select x.CisDok,x.IdDrdok from (select distinct CisDok,IdDrdok,Blok    from inserted union select distinct CisDok,IdDrdok,Blok    from deleted) x where x.Blok=1
  ) x
if @Hlaska>''
begin
 select @Hlaska='Nelze pracovat s dokladem, kter je podepsan, zablokovan nebo je v uzavenm obdob'+char(13)+@Hlaska
 raiserror (@Hlaska,11,2)
 rollback transaction
 return
end
------------------------- nelze zmnit slo dokladu --------------------------------
if @Akce='U'
begin
 select @Hlaska=''
 select @Hlaska=@Hlaska+convert(varchar(15),d.CisDok)+char(13)
  from deleted d left join inserted i on i.CisDok=d.CisDok
  where i.CisDok is null
 if @Hlaska>''
 begin
  select @Hlaska='Nelze mnit slo dokladu'+char(13)+@Hlaska
  raiserror (@Hlaska,11,2)
  rollback transaction
  return
 end
end
---------------------------- patn den dokladu vzhledem k obdob --------------------------
if not @Akce='D'
begin
 select @Hlaska=''
 select @Hlaska=@Hlaska+convert(varchar(15),i.CisDok)+char(13)
  from inserted i
   join dbo.ExObdUc o on i.IdDrdok=o.IdDrdok and i.Obd=o.Obd and i.Rok=o.Rok
  where i.DenDok<o.DenOd or i.DenDok>o.DenDo
 if @Hlaska>''
 begin
  select @Hlaska='patn zadan datum vzhledem k etnmu obdob dokladu'+char(13)+@Hlaska
  raiserror (@Hlaska,11,2)
  rollback transaction
  return
 end
end
---------------------------- zapu do banky nejnovj slo dokladu --------------------------
update b set CisDokBan=xx.CisDokBan
 from
  (
   select x.IdBan,CisDokBan=max(d.CisDok)
    from
     (
       select IdBan,DenDok=max(DenDok) from BaDok group by IdBan
     ) x
     join BaDok d on d.IdBan=x.IdBan and d.DenDok=x.DenDok
    group by x.IdBan
  ) xx
  join BaBan b on b.IdBan=xx.IdBan
 where not b.CisDokBan=xx.CisDokBan

-------------------------------------- zmna kursu - mnm jen tam, kde byl stejn jako v hlavice -------------------------------------------------
if @Akce='U'
begin
 if exists(select i.CisDok from inserted i join deleted d on i.CisDok=d.CisDok where not i.Kurs=d.Kurs and not i.Kurs=0)
 begin
  update r set
    CastkaMena=case when     r.CastkaMena=0 then round(r.CastkaKc  /i.Kurs,@ZaokRadCenaMena) else r.CastkaMena end,
    CastkaKc  =case when not r.CastkaMena=0 then round(r.CastkaMena*i.Kurs,@ZaokRadCenaKc  ) else r.CastkaKc   end,
    Kurs      =i.Kurs
   from dbo.BaRad r join inserted i on i.CisDok=r.CisDok join deleted d on d.CisDok=i.CisDok
   where not i.Kurs=d.Kurs and not i.Kurs=0 and not r.CastkaMena=0 and r.Kurs=d.Kurs
 end
end

END
GO