--NazUpg: prava dk pjemek
--PopisUpg: Skladov poloky - rov kdy
--KontrolaUpg: 
--ChybaUpg:
--VypniOstatni: 0
--VypniPoUpg: 0
--ChybaHlasit: 1 
GO
ALTER TRIGGER dbo.trPrRadInsUpdDel ON dbo.PrRad
FOR INSERT,UPDATE,DELETE
AS
BEGIN
set nocount on
-----------------------------------------------------------------------------------------------
-- jak akce 
declare @Akce char(1)
if (select count(*) from inserted)>0   select @Akce='I'
if (select count(*) from  deleted)>0   select @Akce=case when @Akce='I' then 'U' else 'D' end
if @Akce is null
 return
-------------------------------------------------------------------------------------------------------
--  souet dk do hlaviky
-- tato akce pes ouchnut do hlaviky zkontroluje obdob a blokovn hlaviky
declare @c table (CisDok decimal(15,0) not null primary key)
-- pi update zapisuji jen do hlaviek, kterm se mn cena, prmr, zbo, stedisko
-- tedy umonm zmnit dimenze krom stediska!!!
if @Akce='U'
 insert @c(CisDok)
  select distinct i.CisDok
   from inserted i
    join deleted d on d.IdPrRad=i.IdPrRad
     and not (d.CenaCelkKc=i.CenaCelkKc and d.CenaCelkMena=i.CenaCelkMena and d.CenaPrumCelkKc=i.CenaPrumCelkKc and d.IdZbozi=i.IdZbozi
              and d.MnozCelk=i.MnozCelk and d.VahaCelk=i.VahaCelk
              and d.IdStr=i.IdStr)
-- insert a delete automaticky soutuje do hlaviky
else if @Akce='I'
 insert @c(CisDok)
  select distinct i.CisDok
   from inserted i
else 
 insert @c(CisDok)
  select distinct d.CisDok
   from deleted d
-- a te soutuji do dotench hlaviek
update d
 set CenaCelkKc=x.CenaCelkKc,CenaCelkMena=x.CenaCelkMena
 from
  (
   select c.CisDok
     ,CenaCelkKc    =isnull(sum(r.CenaCelkKc    ),0)
     ,CenaCelkMena  =isnull(sum(r.CenaCelkMena  ),0)
     ,CenaPrumCelkKc=isnull(sum(r.CenaPrumCelkKc),0)
    from @c c
     left join PrRad r (nolock) on r.CisDok=c.CisDok
    group by c.CisDok
  ) x
  join PrDok d (nolock) on d.CisDok=x.CisDok
-------------------------------------------------------------------------------------------------------
-- zpis do stavu na skladu
insert dbo.CeStavGen (IdZbozi,  Komise,  IdStr,  Misto,  Serie,      DoStavu ,      ZakazMinus ,      MnozCelk ,      VahaCelk ,      CenaPrumCelkKc)
 select             x.IdZbozi,x.Komise,x.IdStr,x.Misto,x.Serie,min(c.DoStavu),min(c.ZakazMinus),sum(x.MnozCelk),sum(x.VahaCelk),sum(x.CenaPrumCelkKc)
  from
   (
    select IdZbozi,Komise,IdStr,Misto,Serie, MnozCelk, VahaCelk, CenaPrumCelkKc from inserted union all
    select IdZbozi,Komise,IdStr,Misto,Serie,-MnozCelk,-VahaCelk,-CenaPrumCelkKc from deleted
   ) x
   join CeZbozi c (nolock) on c.IdZbozi=x.IdZbozi and c.Dostavu>'0'
  group by x.IdZbozi,x.Komise,x.IdStr,x.Misto,x.Serie
  having not (sum(x.MnozCelk)=0 and sum(x.VahaCelk)=0 and sum(x.CenaPrumCelkKc)=0)
-- zpis do pehledu pohyb
if (select count(*) from  deleted)>0
 delete p from dbo.SkPohyb p (nolock) join deleted d on p.IdRad=d.IdPrRad and p.IdDrdok='PR'
if (select count(*) from inserted)>0
 insert dbo.SkPohyb (PorPohyb,  IdRad  ,  CisDok,  RadDok,  IdDrdok,  IdZbozi,  Komise,  IdStr     ,  Misto     ,  IdAdr, DenDok                                             , HodDok                                                ,  Obd,  Rok,  Mes,  MnozCelk,  VahaCelk,  CenaPrumCelkKc, Koef,  Serie)
  select              11     ,r.IdPrRad,r.CisDok,r.RadDok,h.IdDrdok,r.IdZbozi,r.Komise,r.IdStr     ,r.Misto     ,h.IdAdr, convert(datetime,convert(varchar,h.DenDok,101),101), convert(tinyint,left(convert(varchar,h.DenDok,114),2)),h.Obd,h.Rok,h.Mes,r.MnozCelk,r.VahaCelk,r.CenaPrumCelkKc, 1   ,r.Serie
   from inserted r join PrDok h (nolock) on r.CisDok=h.CisDok
-------------------------------------------------------------------------------------------------------
-- zpis ceny z pjemky do nkupn ceny
declare @PrCenaDoCeniku bit
select  @PrCenaDoCeniku=dbo.fnChar2Bit(dbo.fnNastav('PrCenaDoCeniku',''))
if @PrCenaDoCeniku=1
begin
 -- vyberu kladn ceny do pomocn tabulky (group kdyby byla poloka na pjemce vcekrt)
 declare @Cena table (
   IdPrRad  int not null primary key
  ,IdZbozi  char(25) collate SQL_Czech_CP1250_CI_AS
  ,IdMena   char(5 ) collate SQL_Czech_CP1250_CI_AS
  ,Kurs     decimal(19,6)
  ,CenaMjKc money
  ,CenaMjMena money
 )
 insert @Cena (IdPrRad ,  IdZbozi,  IdMena,  Kurs,      CenaMjKc ,      CenaMjMena)
  select max(i.IdPrRad),i.IdZbozi,p.IdMena,p.Kurs,max(i.CenaMjKc),max(i.CenaMjMena)
   from inserted i
    join PrDok p (nolock) on p.CisDok=i.CisDok
   where i.CenaMjKc>0
   group by i.IdZbozi,p.IdMena,p.Kurs
 -- zmna ji existujc ceny
 update cn set CenaA=convert(money,case when i.IdMena='0' then i.CenaMjKc else i.CenaMjMena end), Kurs=i.Kurs
  from @Cena i
   join CeCenaNak cn (nolock) on i.IdZbozi=cn.IdZbozi and cn.IdMena=i.IdMena
  where not cn.CenaA=case when i.IdMena='0' then i.CenaMjKc else i.CenaMjMena end
 -- vloen nov ceny
 insert CeCenaNak (IdZbozi, CenaA, IdMena, Kurs)
  select i.IdZbozi,  convert(money,case when i.IdMena='0' then i.CenaMjKc else i.CenaMjMena end),i.IdMena,i.Kurs
   from @Cena i
    left join CeCenaNak xx (nolock) on i.IdZbozi=xx.IdZbozi and xx.IdMena=i.IdMena
   where xx.IdZbozi is null
end
-------------------------------------------------------------------------------------------------------
-- pokud vytvoil novou skladovou poloku s slem dku
if exists(
 select *
  from inserted i
  join SkPol sp (nolock) on sp.IdSkPol=i.IdSkPol and sp.IdPrRad<0
  where i.IdSkPol is not null
)
 update sp set IdPrRad=i.IdPrRad
  from inserted i
   join SkPol sp (nolock) on sp.IdSkPol=i.IdSkPol and sp.IdPrRad<0
  where i.IdSkPol is not null
END
GO