--NazUpg: Pomcky
--PopisUpg: Napojen na nov id. adrese
--KontrolaUpg: 
--ChybaUpg: 
--VypniOstatni: 0
--VypniPoUpg: 1
--ChybaHlasit: 1
GO
CREATE TRIGGER dbo.tiBpPomInsUpd ON dbo.BpPom
INSTEAD OF INSERT,UPDATE
AS
BEGIN
set nocount on
set datefirst 1
---------------- uren akce, ppadn ukonen, kdy se nic nedje --------------
declare @Akce char(1)
if (select count(*) from inserted)>0   select @Akce='I'
if (select count(*) from  deleted)>0   select @Akce=case when @Akce='I' then 'U' else 'D' end
if @Akce is null
 return
-----------------------------------------------------------------------------
-- pomocn tabulka s daty
declare @ins table (
 IdPom      int,
 KodPom     varchar(50) COLLATE SQL_Czech_CP1250_CI_AS,
 NazPom     varchar(500) COLLATE SQL_Czech_CP1250_CI_AS,
 IdPomSkup  int,
 IdPomTyp   int,
 OdpisMes   int,
 NevratMes  int,
 NevratProc decimal(19,6),
 Vratit     bit,
 Opakovane  bit,
 CenaKc     money,
 CenaNakKc  money,
 Odpisproc  money,
 DnyObj     int,
 IdZbozi    char(25) COLLATE SQL_Czech_CP1250_CI_AS,
 IdAdAdr    int,
 IdAdr      varchar(50) COLLATE SQL_Czech_CP1250_CI_AS,
 Blok       char(1) COLLATE SQL_Czech_CP1250_CI_AS,
 Stav       char(1) COLLATE SQL_Czech_CP1250_CI_AS,
 Otisk      varbinary(8),
 idid       int identity(1,1) NOT NULL primary key
)
insert @ins(IdPom,  KodPom,  NazPom,  IdPomSkup,  IdPomTyp,  OdpisMes,  NevratMes,  NevratProc,  Vratit,  Opakovane,  CenaKc,  CenaNakKc,  Odpisproc,  DnyObj,  IdZbozi,  IdAdAdr,  IdAdr,  Blok,  Stav,  Otisk )
 select   i.IdPom,i.KodPom,i.NazPom,i.IdPomSkup,i.IdPomTyp,i.OdpisMes,i.NevratMes,i.NevratProc,i.Vratit,i.Opakovane,i.CenaKc,i.CenaNakKc,i.Odpisproc,i.DnyObj,i.IdZbozi,i.IdAdAdr,i.IdAdr,i.Blok,i.Stav,i.Otisk 
   from inserted i
-----------------------------------------------------------------------------
----- IdAdr x IdAdAdr
-- pi vloen novho najdu id podle kle, pokud id nezadal
if @Akce='I'
 if exists(select * from @ins i where i.IdAdAdr=0 and i.IdAdr>'0')
  update i set IdAdAdr=a.IdAdAdr
   from @ins i
    join AdAdr a (nolock) on a.IdAdr=i.IdAdr
   where i.IdAdAdr=0 and i.IdAdr>'0'
-- pokud zmnm kl, najdu k nmu id
if @Akce='U'
 if exists(select * from @ins i join deleted d on d.IdPom=i.IdPom where not d.IdAdr=i.IdAdr)
  update i set IdAdAdr=a.IdAdAdr
   from @ins i
    join deleted d on d.IdPom=i.IdPom
    join AdAdr a (nolock) on a.IdAdr=i.IdAdr
   where not d.IdAdr=i.IdAdr and not i.IdAdAdr=a.IdAdAdr
-- te sladm kl podle id, protoe id u je dobe
update i set IdAdr=a.IdAdr
 from @ins i
  join AdAdr a (nolock) on a.IdAdAdr=i.IdAdAdr
 where not i.IdAdr=a.IdAdr
-----------------------------------------------------------------------------
-- vlastn insert
if @Akce='I'
begin
insert BpPom(KodPom,  NazPom,  IdPomSkup,  IdPomTyp,  OdpisMes,  NevratMes,  NevratProc,  Vratit,  Opakovane,  CenaKc,  CenaNakKc,  Odpisproc,  DnyObj,  IdZbozi,  IdAdAdr,  IdAdr,  Blok,  Stav)
 select    i.KodPom,i.NazPom,i.IdPomSkup,i.IdPomTyp,i.OdpisMes,i.NevratMes,i.NevratProc,i.Vratit,i.Opakovane,i.CenaKc,i.CenaNakKc,i.Odpisproc,i.DnyObj,i.IdZbozi,i.IdAdAdr,i.IdAdr,i.Blok,i.Stav
   from @ins i
end
-----------------------------------------------------------------------------
-- vlastn update
if @Akce='U'
begin
 update c set
   NazPom    =i.NazPom
  ,IdPomSkup =i.IdPomSkup
  ,IdPomTyp  =i.IdPomTyp
  ,OdpisMes  =i.OdpisMes
  ,NevratMes =i.NevratMes
  ,NevratProc=i.NevratProc
  ,Vratit    =i.Vratit
  ,Opakovane =i.Opakovane
  ,CenaKc    =i.CenaKc
  ,CenaNakKc =i.CenaNakKc
  ,Odpisproc =i.Odpisproc
  ,DnyObj    =i.DnyObj
  ,IdZbozi   =i.IdZbozi
  ,IdAdAdr   =i.IdAdAdr
  ,IdAdr     =i.IdAdr
  ,Blok      =i.Blok
  ,Stav      =i.Stav
 from dbo.BpPom c join @ins i on i.IdPom=c.IdPom
end
END
GO