--NazUpg: Umstn
--PopisUpg: Strukturalizace mst (regl/mstnost/objekt)
--ChybaUpg:
--VypniOstatni: 0
--VypniPoUpg: 0
--ChybaHlasit: 1
GO
----------------------------------------------------------------------------------------------
-- drop table dbo.ExMistoRegal
if object_id('dbo.ExMistoRegal') is null
begin
 CREATE TABLE dbo.ExMistoRegal(
   IdExMistoRegal int IDENTITY(1,1) NOT NULL
  ,KodMistoRegal  varchar(50) COLLATE SQL_Czech_CP1250_CI_AS NOT NULL
  ,NazMistoRegal  varchar(250) COLLATE SQL_Czech_CP1250_CI_AS NOT NULL constraint DF_ExMistoRegal_NazMistoRegal default('')
  ,Rozlis1        varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Rozlis2        varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Rozlis3        varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Rozlis4        varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Rozlis5        varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Blok           bit NOT NULL constraint DF_ExMistoRegal_Blok default (0)
  ,Stav           char(1) COLLATE SQL_Czech_CP1250_CI_AS NOT NULL constraint DF_ExMistoRegal_Stav default ('')
  ,Otisk          timestamp NULL
  ,CONSTRAINT PK_ExMistoRegal PRIMARY KEY CLUSTERED (IdExMistoRegal)
 ) 
end
GO
grant all on dbo.ExMistoRegal to RoleVse
GO
if not exists(select * from sysindexes where name='UN_ExMistoRegal_KodMistoRegal')
 create unique index UN_ExMistoRegal_KodMistoRegal on ExMistoRegal(KodMistoRegal)
GO
if not exists(select * from ExMistoRegal where IdExMistoRegal=0)
begin
 set identity_insert ExMistoRegal on
 insert ExMistoRegal(IdExMistoRegal,KodMistoRegal,NazMistoRegal)
  select 0,'',''
 set identity_insert ExMistoRegal off
end
GO
----------------------------------------------------------------------------------------------
-- drop table dbo.ExMistoMistnost
if object_id('dbo.ExMistoMistnost') is null
begin
 CREATE TABLE dbo.ExMistoMistnost(
   IdExMistoMistnost int IDENTITY(1,1) NOT NULL
  ,KodMistoMistnost  varchar(50) COLLATE SQL_Czech_CP1250_CI_AS NOT NULL
  ,NazMistoMistnost  varchar(250) COLLATE SQL_Czech_CP1250_CI_AS NOT NULL constraint DF_ExMistoMistnost_NazMistoMistnost default('')
  ,Rozlis1           varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Rozlis2           varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Rozlis3           varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Rozlis4           varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Rozlis5           varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Blok              bit NOT NULL constraint DF_ExMistoMistnost_Blok default (0)
  ,Stav              char(1) COLLATE SQL_Czech_CP1250_CI_AS NOT NULL constraint DF_ExMistoMistnost_Stav default ('')
  ,Otisk             timestamp NULL
  ,CONSTRAINT PK_ExMistoMistnost PRIMARY KEY CLUSTERED (IdExMistoMistnost)
 ) 
end
GO
grant all on dbo.ExMistoMistnost to RoleVse
GO
if not exists(select * from sysindexes where name='UN_ExMistoMistnost_KodMistoMistnost')
 create unique index UN_ExMistoMistnost_KodMistoMistnost on ExMistoMistnost(KodMistoMistnost)
GO
if not exists(select * from ExMistoMistnost where IdExMistoMistnost=0)
begin
 set identity_insert ExMistoMistnost on
 insert ExMistoMistnost(IdExMistoMistnost,KodMistoMistnost,NazMistoMistnost)
  select 0,'',''
 set identity_insert ExMistoMistnost off
end
GO
----------------------------------------------------------------------------------------------
-- drop table dbo.ExMistoObjekt
if object_id('dbo.ExMistoObjekt') is null
begin
 CREATE TABLE dbo.ExMistoObjekt(
   IdExMistoObjekt int IDENTITY(1,1) NOT NULL
  ,KodMistoObjekt  varchar(50) COLLATE SQL_Czech_CP1250_CI_AS NOT NULL
  ,NazMistoObjekt  varchar(250) COLLATE SQL_Czech_CP1250_CI_AS NOT NULL constraint DF_ExMistoObjekt_NazMistoObjekt default('')
  ,Rozlis1         varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Rozlis2         varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Rozlis3         varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Rozlis4         varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Rozlis5         varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Blok            bit NOT NULL constraint DF_ExMistoObjekt_Blok default (0)
  ,Stav            char(1) COLLATE SQL_Czech_CP1250_CI_AS NOT NULL constraint DF_ExMistoObjekt_Stav default ('')
  ,Otisk           timestamp NULL
  ,CONSTRAINT PK_ExMistoObjekt PRIMARY KEY CLUSTERED (IdExMistoObjekt)
 ) 
end
GO
grant all on dbo.ExMistoObjekt to RoleVse
GO
if not exists(select * from sysindexes where name='UN_ExMistoObjekt_KodMistoObjekt')
 create unique index UN_ExMistoObjekt_KodMistoObjekt on ExMistoObjekt(KodMistoObjekt)
GO
if not exists(select * from ExMistoObjekt where IdExMistoObjekt=0)
begin
 set identity_insert ExMistoObjekt on
 insert ExMistoObjekt(IdExMistoObjekt,KodMistoObjekt,NazMistoObjekt)
  select 0,'',''
 set identity_insert ExMistoObjekt off
end
GO
----------------------------------------------------------------------------------------------
-- drop table dbo.ExMistoOblast
if object_id('dbo.ExMistoOblast') is null
begin
 CREATE TABLE dbo.ExMistoOblast(
   IdExMistoOblast int IDENTITY(1,1) NOT NULL
  ,KodMistoOblast  varchar(50) COLLATE SQL_Czech_CP1250_CI_AS NOT NULL
  ,NazMistoOblast  varchar(250) COLLATE SQL_Czech_CP1250_CI_AS NOT NULL constraint DF_ExMistoOblast_NazMistoOblast default('')
  ,Rozlis1         varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Rozlis2         varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Rozlis3         varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Rozlis4         varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Rozlis5         varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
  ,Blok            bit NOT NULL constraint DF_ExMistoOblast_Blok default (0)
  ,Stav            char(1) COLLATE SQL_Czech_CP1250_CI_AS NOT NULL constraint DF_ExMistoOblast_Stav default ('')
  ,Otisk           timestamp NULL
  ,CONSTRAINT PK_ExMistoOblast PRIMARY KEY CLUSTERED (IdExMistoOblast)
 ) 
end
GO
grant all on dbo.ExMistoOblast to RoleVse
GO
if not exists(select * from sysindexes where name='UN_ExMistoOblast_KodMistoOblast')
 create unique index UN_ExMistoOblast_KodMistoOblast on ExMistoOblast(KodMistoOblast)
GO
if not exists(select * from ExMistoOblast where IdExMistoOblast=0)
begin
 set identity_insert ExMistoOblast on
 insert ExMistoOblast(IdExMistoOblast,KodMistoOblast,NazMistoOblast)
  select 0,'',''
 set identity_insert ExMistoOblast off
end
GO
----------------------------------------------------------------------------------------------
if not exists(select * from sysobjects o join syscolumns c on c.id=o.Id where o.name='ExMisto' and c.name='IdExMistoRegal')
 alter table ExMisto add IdExMistoRegal int not null constraint DF_ExMisto_IdExMistoRegal default (0)
if not exists(select * from sysobjects o join syscolumns c on c.id=o.Id where o.name='ExMisto' and c.name='IdExMistoMistnost')
 alter table ExMisto add IdExMistoMistnost int not null constraint DF_ExMisto_IdExMistoMistnost default (0)
if not exists(select * from sysobjects o join syscolumns c on c.id=o.Id where o.name='ExMisto' and c.name='IdExMistoObjekt')
 alter table ExMisto add IdExMistoObjekt int not null constraint DF_ExMisto_IdExMistoObjekt default (0)
if not exists(select * from sysobjects o join syscolumns c on c.id=o.Id where o.name='ExMisto' and c.name='IdExMistoOblast')
 alter table ExMisto add IdExMistoOblast int not null constraint DF_ExMisto_IdExMistoOblast default (0)
GO
if not exists(select * from sysobjects o where o.name='FK_ExMisto_IdExMistoRegal')
 alter table ExMisto add constraint FK_ExMisto_IdExMistoRegal foreign key (IdExMistoRegal) references ExMistoRegal(IdExMistoRegal)
if not exists(select * from sysobjects o where o.name='FK_ExMisto_IdExMistoMistnost')
 alter table ExMisto add constraint FK_ExMisto_IdExMistoMistnost foreign key (IdExMistoMistnost) references ExMistoMistnost(IdExMistoMistnost)
if not exists(select * from sysobjects o where o.name='FK_ExMisto_IdExMistoObjekt')
 alter table ExMisto add constraint FK_ExMisto_IdExMistoObjekt foreign key (IdExMistoObjekt) references ExMistoObjekt(IdExMistoObjekt)
if not exists(select * from sysobjects o where o.name='FK_ExMisto_IdExMistoOblast')
 alter table ExMisto add constraint FK_ExMisto_IdExMistoOblast foreign key (IdExMistoOblast) references ExMistoOblast(IdExMistoOblast)
GO
----------------------------------------------------------------------------------------------
if not exists(select * from sysobjects o join syscolumns c on c.id=o.Id where o.name='ExMisto' and c.name='Rozlis1')
 alter table ExMisto add Rozlis1 varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
if not exists(select * from sysobjects o join syscolumns c on c.id=o.Id where o.name='ExMisto' and c.name='Rozlis2')
 alter table ExMisto add Rozlis2 varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
if not exists(select * from sysobjects o join syscolumns c on c.id=o.Id where o.name='ExMisto' and c.name='Rozlis3')
 alter table ExMisto add Rozlis3 varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
if not exists(select * from sysobjects o join syscolumns c on c.id=o.Id where o.name='ExMisto' and c.name='Rozlis4')
 alter table ExMisto add Rozlis4 varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
if not exists(select * from sysobjects o join syscolumns c on c.id=o.Id where o.name='ExMisto' and c.name='Rozlis5')
 alter table ExMisto add Rozlis5 varchar(50) COLLATE SQL_Czech_CP1250_CI_AS
GO
----------------------------------------------------------------------------------------------
DBCC INDEXDEFRAG(0,'ExMisto')
GO