--NazUpg: Odvody
--PopisUpg: Kontrola dat ped zpisem odvod
--KontrolaUpg:
--ChybaUpg:
--VypniOstatni: 0
--VypniPoUpg: 0
--ChybaHlasit: 1
if object_id('dbo.tiMzOdvMesInsUpdDel') is not null drop trigger dbo.tiMzOdvMesInsUpdDel
GO
CREATE TRIGGER dbo.tiMzOdvMesInsUpdDel on dbo.MzOdvMes
INSTEAD OF INSERT, UPDATE, DELETE
as
BEGIN
set nocount on
---------------- uren akce, ppadn ukonen, kdy se nic nedje --------------
declare @Akce char(1)
if (select count(*) from inserted)>0   select @Akce='I'
if (select count(*) from  deleted)>0   select @Akce=case when @Akce='I' then 'U' else 'D' end
if @Akce is null
 return
--
declare @Hlaska varchar(4000) select @Hlaska=''
-----------------------------------------------------------------------------------------------------------------------
-- nesahm natvrdo do odvod (mimo korekce)?
if not exists (select * from ExTrigger (nolock) where Kdo=user_name() and Co='spMzVycMes')
begin
 select @Hlaska=@Hlaska+rtrim(x.IdClovek)+'/'+rtrim(x.IdOdv)+', '
  from 
   (select * from inserted where JeKorekce=0 union all
    select * from  deleted where JeKorekce=0
   ) x
   group by x.IdClovek,x.IdOdv
 if @Hlaska>''
 begin
  select @Hlaska='Nelze run natvrdo mnit odvody, pouijte korekce odvod '+left(@Hlaska,len(rtrim(@Hlaska))-1)
  raiserror(@Hlaska,11,2)
  rollback tran
  return
 end
end
-----------------------------------------------------------------------------------------------------------------------
-- smazn
if @Akce='D'
begin
 delete x from dbo.MzOdvMes x join deleted d on d.IdOdvMes=x.IdOdvMes
 return
end
-----------------------------------------------------------------------------------------------------------------------
-- kontrola vazby lovka na zamstnance
select @Hlaska=@Hlaska+rtrim(x.IdZam)+'/'+rtrim(x.IdClovek)+', '
 from
  (select i.* from inserted i join MzZam z (nolock) on z.IdZam=i.IdZam where i.IdZam>'0' and i.IdClovek>'0' and not z.IdClovek=i.IdClovek
  ) x
  group by x.IdZam,x.IdClovek
if @Hlaska>''
begin
 select @Hlaska='V odvodech nesouhlas vazba sla zamstnance na slo osoby '+left(@Hlaska,len(rtrim(@Hlaska))-1)
 raiserror(@Hlaska,11,2)
 rollback tran
 return
end
------------------------------------------------------------------------------------------------------------------------
-- zdravotn a sociln mus mt zamstnance
select @Hlaska=@Hlaska+rtrim(x.IdClovek)+', '
 from
  (select i.* from inserted i where not i.IdZam>'0' and not i.IdOdvTyp='da'
  ) x
  group by x.IdClovek
if @Hlaska>''
begin
 select @Hlaska='Sociln a zdravotn odvody mus mt zadno slo zamstnance '+left(@Hlaska,len(rtrim(@Hlaska))-1)
 raiserror (@Hlaska,11,2)
 rollback tran
 return
end
-----------------------------------------------------------------------------------------------------------------------
-- pi update neumonm zmnit IdClovek
select @Hlaska=@Hlaska+rtrim(x.IdClovekStary)+'->'+rtrim(x.IdClovekNovy)+', '
 from
  (select IdClovekStary=d.IdClovek,IdClovekNovy=i.IdClovek
    from inserted i join deleted d on d.IdOdvMes=i.IdOdvMes
    where not i.IdClovek=d.IdClovek and i.IdClovek>'0' and d.IdClovek>'0'
  ) x
  group by x.IdClovekStary,x.IdClovekNovy
if @Hlaska>''
begin
 select @Hlaska='V odvodech nen mon mnit osobu '+left(@Hlaska,len(rtrim(@Hlaska))-1)
 raiserror (@Hlaska,11,2)
 rollback tran
 return
end
----------------------------------------------------------------------------------
declare @ins table(
  IdOdvMes int
 ,IdClovek char(10) collate SQL_Czech_CP1250_CI_AS NOT NULL 
 ,IdZam char(10) collate SQL_Czech_CP1250_CI_AS NOT NULL 
 ,Mes char(7) collate SQL_Czech_CP1250_CI_AS NOT NULL 
 ,IdOdv char(15) collate SQL_Czech_CP1250_CI_AS NOT NULL 
 ,IdOdvTyp char(3) collate SQL_Czech_CP1250_CI_AS NOT NULL 
 ,VycKc money NOT NULL 
 ,OdpKc money NOT NULL 
 ,ZakKc money NOT NULL 
 ,PuvZamKc money NOT NULL 
 ,PuvFirKc money NOT NULL 
 ,ZvyhodZamKc money NOT NULL 
 ,ZvyhodFirKc money NOT NULL 
 ,SlevaZamKc money NOT NULL 
 ,SlevaFirKc money NOT NULL 
 ,BonusZamKc money NOT NULL 
 ,BonusFirKc money NOT NULL 
 ,OdvZamKc money NOT NULL 
 ,OdvFirKc money NOT NULL 
 ,Blok char(1) collate SQL_Czech_CP1250_CI_AS NOT NULL 
 ,Stav char(1) collate SQL_Czech_CP1250_CI_AS NOT NULL 
 ,ZarKdo char(20) collate SQL_Czech_CP1250_CI_AS NOT NULL 
 ,ZarKdy datetime NOT NULL 
 ,OprKdo char(20) collate SQL_Czech_CP1250_CI_AS NOT NULL 
 ,OprKdy datetime
 ,Otisk timestamp
 ,JeKorekce bit NOT NULL 
 ,idid int identity(1,1) NOT NULL primary key
)
-- pi naten dat zrovna opravm
insert @ins(Mes ,  IdOdv ,  VycKc ,  OdpKc ,  ZakKc ,  PuvZamKc ,  PuvFirKc ,  ZvyhodZamKc ,  ZvyhodFirKc ,  SlevaZamKc ,  SlevaFirKc ,  BonusZamKc ,  BonusFirKc ,  OdvZamKc ,  OdvFirKc ,  JeKorekce,  Blok,  Stav,  ZarKdo,  ZarKdy,  OprKdo,  OprKdy, IdClovek, IdZam, IdOdvTyp)
 select   i.Mes ,i.IdOdv ,i.VycKc ,i.OdpKc ,i.ZakKc ,i.PuvZamKc ,i.PuvFirKc ,i.ZvyhodZamKc ,i.ZvyhodFirKc ,i.SlevaZamKc ,i.SlevaFirKc ,i.BonusZamKc ,i.BonusFirKc ,i.OdvZamKc ,i.OdvFirKc ,i.JeKorekce,i.Blok,i.Stav,i.ZarKdo,i.ZarKdy,i.OprKdo,i.OprKdy
   ,IdClovek=case when i.IdZam>'0' then z.IdClovek else i.IdClovek end
   ,IdZam   =case when odv.IdOdvTyp='da' then '' else i.IdZam end
   ,IdOdvTyp=odv.IdOdvTyp
  from inserted i
   join MzOdv odv (nolock) on odv.IdOdv=i.IdOdv
   join MzZam z (nolock) on z.IdZam=i.IdZam
------------------------------- vlastn insert -------------------------------------
if @Akce='I'
begin
 insert MzOdvMes(IdClovek ,  IdZam ,  Mes ,  IdOdv ,  IdOdvTyp ,  VycKc ,  OdpKc ,  ZakKc ,  PuvZamKc ,  PuvFirKc ,  ZvyhodZamKc ,  ZvyhodFirKc ,  SlevaZamKc ,  SlevaFirKc ,  BonusZamKc ,  BonusFirKc ,  OdvZamKc ,  OdvFirKc ,  JeKorekce,  Blok,  Stav,  ZarKdo,  ZarKdy,  OprKdo,  OprKdy)
  select       i.IdClovek ,i.IdZam ,i.Mes ,i.IdOdv ,i.IdOdvTyp ,i.VycKc ,i.OdpKc ,i.ZakKc ,i.PuvZamKc ,i.PuvFirKc ,i.ZvyhodZamKc ,i.ZvyhodFirKc ,i.SlevaZamKc ,i.SlevaFirKc ,i.BonusZamKc ,i.BonusFirKc ,i.OdvZamKc ,i.OdvFirKc ,i.JeKorekce,i.Blok,i.Stav,i.ZarKdo,i.ZarKdy,i.OprKdo,i.OprKdy
   from @ins i
end
------------------------------- vlastn update -------------------------------------
if @Akce='U'
begin
 update o set
   IdClovek    =i.IdClovek
  ,IdZam       =i.IdZam
  ,Mes         =i.Mes
  ,IdOdv       =i.IdOdv
  ,IdOdvTyp    =i.IdOdvTyp
  ,VycKc       =i.VycKc
  ,OdpKc       =i.OdpKc
  ,ZakKc       =i.ZakKc
  ,PuvZamKc    =i.PuvZamKc
  ,PuvFirKc    =i.PuvFirKc
  ,ZvyhodZamKc =i.ZvyhodZamKc
  ,ZvyhodFirKc =i.ZvyhodFirKc
  ,SlevaZamKc  =i.SlevaZamKc
  ,SlevaFirKc  =i.SlevaFirKc
  ,BonusZamKc  =i.BonusZamKc
  ,BonusFirKc  =i.BonusFirKc
  ,OdvZamKc    =i.OdvZamKc
  ,OdvFirKc    =i.OdvFirKc
  ,JeKorekce   =i.JeKorekce
  ,Blok        =i.Blok
  ,Stav        =i.Stav
  ,ZarKdo      =i.ZarKdo
  ,ZarKdy      =i.ZarKdy
  ,OprKdo      =i.OprKdo
  ,OprKdy      =i.OprKdy
 from dbo.MzOdvMes o join @ins i on i.IdOdvMes=o.IdOdvMes
end
END
GO