--NazUpg: Generovn dochzky
--PopisUpg: Hromadn generovn jeden po druhm
--KontrolaUpg: 
--ChybaUpg: 
--VypniOstatni: 0
--VypniPoUpg: 1
--ChybaHlasit: 1
GO
ALTER PROCEDURE dbo.spMzDochMesGen(@Mes char(7),@PodmZam varchar(50)='0',@SmazatStarou bit=0) as
BEGIN
-- Vygenerovn dochzky zamstnanc podle ablony dochzky vazku
/*
declare @Mes          char(7)      select @Mes         ='2019/02'
declare @PodmZam      varchar(100) select @PodmZam     ='00003h2'
declare @SmazatStarou bit          select @SmazatStarou=1
*/
-- kontrola msce
if (select count(*) from MzMes (nolock) where Mes=@Mes and @Mes>'0' and PovolMz>'0')=0
begin
 raiserror ('Zadan obdob pro generovn dochzky zamstnanc je uzaven nebo vbec neexistuje.',11,2)
 rollback transaction
 return
end
-- podmnka na zamstnance
if not @PodmZam>'0'
 select @PodmZam='%'
else
 select @PodmZam=replace(ltrim(rtrim(@PodmZam)),'*','%')
---------------------------------------------------------------------
-- seznam zamstnanc
declare @z table (
  idid   int identity(1,1) not null primary key
 ,IdZam  varchar(10) collate SQL_Czech_CP1250_CI_AS
 ,IdUvaz varchar(10) collate SQL_Czech_CP1250_CI_AS
 ,JeSvatekVeMzde bit
 ,IdPol  varchar(10) collate SQL_Czech_CP1250_CI_AS
 ,DenOd  datetime
 ,DenDo  datetime
 ,PomerOd datetime
 ,PomerDo datetime
)
insert @z (IdZam,   IdUvaz,   JeSvatekVeMzde,   IdPol,   DenOd,   DenDo,  PomerOd,  PomerDo)
 select zm.IdZam,zm.IdUvaz,zm.JeSvatekVeMzde,pz.IdPol,pz.DenOd,pz.DenDo,z.DenOd  ,dateadd(day,1,z.DenDo)
  from  MzZamMes  zm (nolock)
   join MzZam     z  (nolock) on z.IdZam=zm.IdZam and z.IdPomer in ('h','j')
   join MzPolZam  pz (nolock) on pz.IdZam=z.IdZam and not @Mes<convert(char(7),pz.DenOd,111) and not @Mes>convert(char(7),pz.DenDo,111)
   join MzPol     p  (nolock) on p.IdPol=pz.IdPol and p.IdDoch='prce'
  where zm.IdZam like @PodmZam and zm.IdZam>'0'
   and zm.Mes=@Mes
---------------------------------------------------------------------
-- smazn star dochzky
if @SmazatStarou=1
 delete d 
  from @z z
   join MzDochMes d (nolock) on d.Mes=@Mes and d.IdZam=z.IdZam
-- vyhodm ze seznamu lidi s dochzkou
else
 delete z
  from @z z
   join MzDochMes d (nolock) on d.IdZam=z.IdZam and d.Mes=@Mes
---------------------------------------------------------------------
-- jak poloka je nhrada za svtek
declare @IdPolSvatek varchar(10)
select @IdPolSvatek=isnull(max(IdPol),'0')
 from MzPol (nolock)
 where IdPolParam='nhrada/svtek' and @Mes between MesOd and MesDo
---------------------------------------------------------------------
-- naplnn MzDochMes
declare @CasOd datetime
declare @IdUvaz varchar(10)
declare @IdZam varchar(10)
-- beru prvnho zamstnance
select @IdZam=min(IdZam) from @z
while @IdZam is not null
begin
 -- zjistm vazek
 select @IdUvaz=min(IdUvaz) from @z where IdZam=@IdZam
 -- nasypu dochzku jednoho zamstnance
 insert MzDochMes( IdZam, Mes,   CasOd,   CasDo,   CelkHod,   PolHod,   JeSvatek,  IdPol,  IdPolPuv)
  select          @IdZam,@Mes,du.CasOd,du.CasDo,du.CelkHod,du.PolHod,du.JeSvatek
    ,IdPol   =case when du.JeSvatek=1 and z.JeSvatekVeMzde=0 then @IdPolSvatek else z.IdPol end
    ,IdPolPuv=case when du.JeSvatek=1 and z.JeSvatekVeMzde=0 then @IdPolSvatek else z.IdPol end
   from MzDochUvaz du (nolock)
     join @z z on z.IdZam=@IdZam and not z.PomerOd>du.CasOd and not z.PomerDo<du.CasOd
   where du.IdUvaz=@IdUvaz and du.Mes=@Mes
 -- dal zamstnanec
 select @IdZam=min(IdZam) from @z where IdZam>@IdZam
end
END
GO