--NazUpg: Odpoty dt
--PopisUpg: Napojen na id. adresta
--KontrolaUpg:
--ChybaUpg:
--VypniOstatni: 0
--VypniPoUpg: 0
--ChybaHlasit: 1
GO
ALTER TRIGGER dbo.tiMzOdpZamInsUpd ON dbo.MzOdpZam
INSTEAD OF INSERT,UPDATE
AS
BEGIN
set nocount on
---------------- uren akce, ppadn ukonen, kdy se nic nedje --------------
declare @Akce char(1)
if (select count(*) from inserted)>0   select @Akce='I'
if (select count(*) from  deleted)>0   select @Akce=case when @Akce='I' then 'U' else 'D' end
if @Akce is null
 return
-----------------------------------------------------------------------------------
declare @ins table (
  IdOdpZam int
 ,IdClovek char(10) collate SQL_Czech_CP1250_CI_AS
 ,IdZam    char(10) collate SQL_Czech_CP1250_CI_AS
 ,IdOdp    char(25) collate SQL_Czech_CP1250_CI_AS
 ,MesOd    char(7) collate SQL_Czech_CP1250_CI_AS
 ,MesDo    char(7) collate SQL_Czech_CP1250_CI_AS
 ,IdVyziv  int
 ,IdAdr    varchar(50) collate SQL_Czech_CP1250_CI_AS
 ,PorVyziv smallint
 ,IdAdAdr  int
 ,Blok     char(1) collate SQL_Czech_CP1250_CI_AS
 ,Stav     char(1) collate SQL_Czech_CP1250_CI_AS
 ,ZarKdo   char(20) collate SQL_Czech_CP1250_CI_AS
 ,ZarKdy   datetime
 ,OprKdo   char(20) collate SQL_Czech_CP1250_CI_AS
 ,OprKdy   datetime
 ,Otisk    varbinary(8)
 ,idid     int identity(1,1) NOT NULL primary key
)
insert @ins(IdOdpZam,  IdClovek,  IdZam,  IdOdp,  MesOd,  MesDo,  IdVyziv,  IdAdr,  PorVyziv,  IdAdAdr,  Blok,  Stav,  ZarKdo,  ZarKdy,  OprKdo,  OprKdy,  Otisk)
 select   i.IdOdpZam,i.IdClovek,i.IdZam,i.IdOdp,i.MesOd,i.MesDo,i.IdVyziv,i.IdAdr,i.PorVyziv,i.IdAdAdr,i.Blok,i.Stav,i.ZarKdo,i.ZarKdy,i.OprKdo,i.OprKdy,i.Otisk
  from inserted i
-----------------------------------------------------------------------------
----- IdAdr x IdAdAdr
-- pi vloen novho najdu id podle kle, pokud id nezadal
if @Akce='I'
 if exists(select * from @ins i where i.IdAdAdr=0 and i.IdAdr>'0')
  update i set IdAdAdr=a.IdAdAdr
   from @ins i
    join AdAdr a (nolock) on a.IdAdr=i.IdAdr
   where i.IdAdAdr=0 and i.IdAdr>'0'
-- pokud zmnm kl, najdu k nmu id
if @Akce='U'
 if exists(select * from @ins i join deleted d on d.IdOdpZam=i.IdOdpZam where not d.IdAdr=i.IdAdr)
  update i set IdAdAdr=a.IdAdAdr
   from @ins i
    join deleted d on d.IdOdpZam=i.IdOdpZam
    join AdAdr a (nolock) on a.IdAdr=i.IdAdr
   where not d.IdAdr=i.IdAdr and not i.IdAdAdr=a.IdAdAdr
-- te sladm kl podle id, protoe id u je dobe
update i set IdAdr=a.IdAdr
 from @ins i
  join AdAdr a (nolock) on a.IdAdAdr=i.IdAdAdr
 where not i.IdAdr=a.IdAdr
----------------------------------------------------------------------------------
-- pravy novch zznam
if @Akce='I'
begin
 -- doplnn lovka podle zamstnance
 update i set i.IdClovek=z.IdClovek
  from @ins i join MzZam z (nolock) on z.IdZam=i.IdZam
  where i.IdZam>'0' and not i.IdClovek>'0'
end
----------------------------------------------------------------------------------
-- pi update neumonm zmnit IdClovek
if @Akce='U'
begin
 update i set i.IdClovek=d.IdClovek
  from @ins i join deleted d on d.IdOdpZam=i.IdOdpZam
  where not i.IdClovek=d.IdClovek
end
----------------------------------------------------------------------------------
-- kontrola vazby lovka na zamstnance
if exists(select * from @ins i join MzZam z (nolock) on z.IdZam=i.IdZam where i.IdZam>'0' and not z.IdClovek=i.IdClovek)
begin
 raiserror ('Nesouhlas vazba sla zamstnance na slo osoby',11,2)
 rollback tran
 return
end
----------------------------------------------------------------------------------
-- dti
----------------------------------------------------------------------------------
-- odpoet na dt se mus vzat na njak dt
if exists(select * from @ins i where i.IdOdp like 'da/vyivovan%' and not i.IdVyziv>0)
begin
 raiserror ('Pi zadn odpotu na vyivovanou osobu muste njakou vyivovanou osobu zadat!',11,2)
 rollback tran
 return
end
-- kontrola vazby lovka na vyivovanou osobu
if exists(select * from @ins i left join MzVyziv v (nolock) on v.IdClovek=i.IdClovek and v.IdVyziv=i.IdVyziv where i.IdVyziv>0 and v.IdVyziv is null)
begin
 raiserror ('Vyivovan osoba nepat dan osob (zamstnanci). Vybrali jste ciz dt!',11,2)
 rollback tran
 return
end
-- nastaven vyivovanch MesOd na datum narozen a MesDo na 18. narozeniny
update i set i.MesOd=left(convert(char(10),                v.DenNar ,111),7) from @ins i join MzVyziv v (nolock) on v.IdVyziv=i.IdVyziv where not (i.MesOd>'1900/13' and i.MesOd<'2222/00') and i.IdVyziv>0
update i set i.MesDo=left(convert(char(10),dateadd(year,18,v.DenNar),111),7) from @ins i join MzVyziv v (nolock) on v.IdVyziv=i.IdVyziv where not (i.MesDo>'1900/13' and i.MesDo<'2222/00') and i.IdVyziv>0
-- dt mohu odepisovat a po jeho narozen
if exists(select * from @ins i join MzVyziv v (nolock) on v.IdVyziv=i.IdVyziv where i.IdVyziv>0 and convert(char(7),v.DenNar,111)>i.MesOd)
begin
 raiserror ('Vyivovanou osobu nelze vyivovat ped jejm narozenm.',11,2)
 rollback tran
 return
end
------------------------------ insert ---------------------------------------------
if @Akce='I'
 insert MzOdpZam (IdClovek,  IdZam,  IdOdp,  MesOd,  MesDo,  IdVyziv,  IdAdr,  PorVyziv,  IdAdAdr,  Blok,  Stav)
  select        i.IdClovek,i.IdZam,i.IdOdp,i.MesOd,i.MesDo,i.IdVyziv,i.IdAdr,i.PorVyziv,i.IdAdAdr,i.Blok,i.Stav
   from @ins i
if @Akce='U'
 update oz set
   IdClovek=i.IdClovek
  ,IdZam   =i.IdZam
  ,IdOdp   =i.IdOdp
  ,MesOd   =i.MesOd
  ,MesDo   =i.MesDo
  ,IdVyziv =i.IdVyziv
  ,IdAdr   =i.IdAdr
  ,PorVyziv=i.PorVyziv
  ,IdAdAdr =i.IdAdAdr
  ,Blok    =i.Blok
  ,Stav    =i.Stav
  ,ZarKdo  =i.ZarKdo
  ,ZarKdy  =i.ZarKdy
  ,OprKdo  =i.OprKdo
  ,OprKdy  =i.OprKdy
  from MzOdpZam oz join @ins i on i.IdOdpZam=oz.IdOdpZam
END
GO